#include <avr/io.h>
#define F_CPU 16000000UL // frekvence hodinovho signlu (nutn pro delay.h)
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h> 
#include "knihovna.c"

#define vlevo 0x03  //definuji smer tlacitek
#define nahoru 0x02
#define dolu 0x01
#define vpravo 0x00
#define pole 0x08

int horizont = 1; //na zacatku jede had po horizontu, 0 znaci vertikalni smer 
int pohyb = vlevo; //potrebujeme vedet, kterym smerem se had pohybuje, na zacatku se had pohybuje doleva
int i; //promenna pro fory
int radek = 0; //udava pozici radku v hadovi a jablku
int zpozdeni = 40; //jeden bod udava zpozdeni 8 ms
int error = 0; //vychozi stav je bez kolize
char index; //uchovava souradnice z hlavy


void tlacitka (void)
{
  if (horizont)
  {
    if (bit_is_clear(PIND,nahoru)) 
	{
	  pohyb = nahoru;
	  horizont = 0;
	}
	if (bit_is_clear(PIND,dolu)) 
	{
	  pohyb = dolu;
	  horizont = 0;
	}
  }
  else
  {
    if (bit_is_clear(PIND,vlevo)) 
	{
	  pohyb = vlevo;
	  horizont = 1;
	}
	if (bit_is_clear(PIND,vpravo)) 
	{
	  pohyb = vpravo;
	  horizont = 1;
	}
  }
}


int main (void)
{
  DDRD = 0x0; //port D nastaven jako vstupni kvuli tlacitkum
  DDRB |= ((1 << 0) | (1 << 1) | (1 << 2)); //piny nastaveny jako vystupni
  DDRA = 0xff; //sviti zelena pro jablko
  DDRC = 0xff; //sviti cervena pro hada
 
  inicializace_souradnic_hada ();
  jablicko (); //vytvorim prvotni nahodnou pozici jablka
  while (1)
  {
    for (i = 0; i < zpozdeni; i++)
      for (radek = 0; radek < pole; radek++)
      {
        PORTB = radek;
        PORTC = dej_hada(radek);
        PORTA = dej_jablko(radek);
		index = dej_hlavu(0);
		if (index == radek)
		{
		  index = dej_hlavu(1);
		  PORTA &= ~(1 << index);
		}
	    _delay_ms (1);
		tlacitka (); //porad testuju, jestli uzivatel nezmackl tlacitko
      }
     error = zmena(pohyb); //po urcite dobe se had vyda zvolenym smerem
	 if (error)
	 {
	   horizont = 1;
	   pohyb = vlevo; //vychozi nastaveni pri kolizi
	 }
  }
}
